#include "stdafx.h"
#include "Sample.h"
#include "SampleDlg.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

CSampleDlg::CSampleDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CSampleDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CSampleDlg)
		// NOTE: the ClassWizard will add member initialization here
	//}}AFX_DATA_INIT
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
}

void CSampleDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CSampleDlg)
		// NOTE: the ClassWizard will add DDX and DDV calls here
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CSampleDlg, CDialog)
	//{{AFX_MSG_MAP(CSampleDlg)
	ON_WM_QUERYDRAGICON()
	ON_BN_CLICKED(IDC_SET_DATA_BTN, OnPrintBtn)
	ON_BN_CLICKED(IDC_GET_DATA_BTN, OnGetInfoBtn)
	ON_BN_CLICKED(IDC_CB_STA_BTN, OnGetCallbackBtn)
	ON_CBN_SELCHANGE(IDC_LISTBOX, OnSelchangeListbox)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()


BOOL CSampleDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	SetIcon(m_hIcon, TRUE);			
	SetIcon(m_hIcon, FALSE);		
	CreatePrinterList();

	TCHAR	lpTitle[1024] = {0};
	wsprintf( lpTitle, TEXT("Sample [%s]"), DLL_FILE_NAME );
	SetWindowText( lpTitle );
	OnSelchangeListbox(); 
	return TRUE;
}

HCURSOR CSampleDlg::OnQueryDragIcon()
{
	return (HCURSOR) m_hIcon;
}

void CSampleDlg::OnPrintBtn() 
{
	WriteSamp();
}

void CSampleDlg::OnGetInfoBtn() 
{
	ReadSamp();
}

void CSampleDlg::OnGetCallbackBtn() 
{
	CButton* pBtn = (CButton*)GetDlgItem(IDC_CB_STA_BTN);
	CListBox* pList = (CListBox*)GetDlgItem(IDC_CB_LIST);

	if( pBtn->GetCheck() )
	{
		CallbackSamp( TRUE );
		pList->ResetContent(); 
		pList->EnableWindow( TRUE );
	}
	else
	{
		CallbackSamp( FALSE );
		pList->EnableWindow( FALSE );
	}
}


void CSampleDlg::OnSelchangeListbox() 
{
	TCHAR	lpPrinterName[MAX_PATH];
	CComboBox* pCombBox = (CComboBox*)GetDlgItem( IDC_LISTBOX );
	CButton* pCbBtn		= (CButton*)GetDlgItem( IDC_CB_STA_BTN );
	CButton* pGetdataBtn= (CButton*)GetDlgItem( IDC_GET_DATA_BTN );
	CButton* pSetdataBtn= (CButton*)GetDlgItem( IDC_SET_DATA_BTN );
	CListBox* pList = (CListBox*)GetDlgItem(IDC_CB_LIST);

	pCbBtn->EnableWindow(FALSE);
	pGetdataBtn->EnableWindow(FALSE);
	pSetdataBtn->EnableWindow(FALSE);
	pList->ResetContent(); 
	pCbBtn->SetCheck( FALSE );

	pCombBox->GetLBText( pCombBox->GetCurSel(), lpPrinterName );
	if( OpenSamp( lpPrinterName ) )
	{
		pList->SetWindowText( TEXT("OPEN ERROR") );
		pCbBtn->EnableWindow(TRUE);
		pGetdataBtn->EnableWindow(TRUE);
		pSetdataBtn->EnableWindow(TRUE);
	}
}



VOID CSampleDlg::CreatePrinterList()
{
	BYTE		*pPrinter;
 	DWORD		cbNeedPr, cbReturnPr;
	DWORD		dwIndex;
	CComboBox*	pCombBox = (CComboBox*)GetDlgItem( IDC_LISTBOX );

	//Get size of structure
 	EnumPrinters( PRINTER_ENUM_LOCAL, NULL,	2, NULL, 0, &cbNeedPr, &cbReturnPr );

	//Get printer info
 	pPrinter = (PBYTE) new BYTE[ cbNeedPr ];
	if( pPrinter )
	{
		if( EnumPrinters( PRINTER_ENUM_LOCAL, NULL, 2, pPrinter, cbNeedPr, &cbNeedPr, &cbReturnPr ) )
		{
			PRINTER_INFO_2* pPrinterInfo2 = (PRINTER_INFO_2 *) pPrinter;
			for( dwIndex=0 ; dwIndex < cbReturnPr; dwIndex++, pPrinterInfo2++ ) 
			{
				if( !_tcsnccmp( TEXT("SII"), pPrinterInfo2->pDriverName, lstrlen( TEXT("SII") ) ) )
				{
					pCombBox->AddString( pPrinterInfo2->pPrinterName );
					pCombBox->SetCurSel( 0 );
				}
 			}
		}
		delete [] pPrinter;
	}

	if( pCombBox->GetCount() == 0 )
	{
		AfxMessageBox( TEXT("Don't find the printer driver") );
	}	
	else
	{
		pCombBox->EnableWindow( TRUE );
	}
}
